Modules/Sam/Routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::controller(SamController::class)
    ->prefix("sam")
    ->name("sam.")
    ->middleware(["auth"])
    ->group(function () {
        Route::get("/actividades", "actividades")->name("actividades");
        Route::get("/unidades", "unidades")->name("unidades");
        Route::get("/etiquetas", "etiquetas")->name("etiquetas");
        Route::get("/solicitudes", "solicitudes")->name("solicitudes");
        Route::get("/actividades/{actividad}/historicos", "historicos")->name(
            "historicos"
        );
    });

Modules/Sam/Entities/Historico.php
<?php

namespace Modules\Sam\Entities;

use App\Models\File;
use App\Models\Revision;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Historico extends Model
{
    use HasFactory;

    protected $fillable = ["estado"];

    //estados constantes
    const CONFIRMED = 2;
    const REJECTED = 3;
    const PENDING = 1;
    const DRAFT = 0;

    const ESTADOS = [
        self::DRAFT => "Borrador",
        self::PENDING => "En revisión",
        self::CONFIRMED => "Aprobado",
        self::REJECTED => "Rechazado",
    ];

    const COLORS = [
        self::DRAFT => "table-secondary",
        self::PENDING => "table-info",
        self::CONFIRMED => "table-success",
        self::REJECTED => "table-danger",
    ];

    public function adjuntos()
    {
        return $this->morphToMany(File::class, "adjunto");
    }

    public function scopeDesde($query, $desde)
    {
        if (isset($desde)) {
            return $query->whereDate("inicio", ">=", $desde);
        }
        return $query;
    }
    public function actividad()
    {
        return $this->belongsTo(Actividad::class);
    }
    public function scopeHasta($query, $hasta)
    {
        if (isset($hasta)) {
            return $query->whereDate("inicio", "<=", $hasta);
        }
        return $query;
    }

    public function revisiones()
    {
        return $this->morphMany(Revision::class, "revisable");
    }

    //revisar puede estar mal
    public function revision()
    {
        return $this->morphMany(
            Revision::class,
            "revisable",
            "revisiones"
        )->latest();
    }

    public function getStatusAttribute()
    {
        return array_values(self::ESTADOS)[intval($this->estado)];
    }
    public function getColorAttribute()
    {
        return array_values(self::COLORS)[intval($this->estado)];
    }
}

Modules/Sam/Http/Livewire/Actividades/Create.php
<?php

namespace Modules\Sam\Http\Livewire\Actividades;

use Carbon\Carbon;
use Livewire\Component;
use Illuminate\Support\Arr;
use Modules\Plan\Entities\Eje;
use Illuminate\Validation\Rule;
use Modules\Sam\Entities\Unidad;
use Illuminate\Support\Facades\DB;
use Modules\Sam\Entities\Etiqueta;
use Modules\Plan\Entities\Programa;
use Modules\Sam\Entities\Actividad;
use Modules\Sam\Entities\Historico;
use Illuminate\Support\Facades\Auth;
use Modules\Plan\Entities\Estrategia;
use Modules\Organizacion\Entities\Area;

class Create extends Component
{
    public $ejes;
    public $areas;
    public $unidades;
    public $etiquetas = [];
    public $model_id,
        $eje_id = -1,
        $programa_id = -1,
        $estrategia_id = -1,
        $area_id = -1,
        $unidad_id = -1,
        $etiquetas_id = [],
        $descripcion,
        $alcance,
        $nombre;

    public function render()
    {
        return view("sam::livewire.actividades.create");
    }

    public function mount()
    {
        $user = Auth::user();
        $colaborador = $user->colaborador;

        $this->etiquetas = Etiqueta::pluck("nombre", "id")->toArray();
        $this->unidades = Unidad::pluck("nombre", "id")->toArray();

        //bloqueos de areas todo o solo la propia
        if ($user->can("sam actividad areas")) {
            $this->areas = Area::pluck("nombre", "id")->toArray();
        } /*elseif ($user->can("sam actividad subareas")) {
            $this->areas = $colaborador->areas
                ->pluck("nombre", "id")
                ->toArray();
        } */ else {
            $this->areas = Arr::pluck([$colaborador->area], "nombre", "id");
        }

        //bloqueos de ejes
        if ($user->can("sam actividad ejes")) {
            $this->ejes = Eje::pluck("nombre", "id")->toArray();
        } else {
            if (isset($colaborador->area)) {
                $this->ejes = $colaborador->area->ejes_sam
                    ->pluck("nombre", "id")
                    ->toArray();
            }
        }
    }

    public function updatedEjeId($value)
    {
        $user = Auth::user();
        $colaborador = $user->colaborador;
        $programas = [];

        //bloqueos de programas
        if ($user->can("sam actividad programas")) {
            $programas = Programa::where("eje_id", $this->eje_id)
                ->select(["id", "nombre as text"])
                ->get();
        } else {
            $programas = $colaborador->area
                ->programas_sam()
                ->where("eje_id", $this->eje_id)
                ->select(["id", "nombre as text"])
                ->get();
        }

        $this->programa_id = null;
        $this->estrategia_id = null;
        $this->emit("setPrograma", $programas, $this->programa_id);
        $this->emit("setEstrategia", [], $this->estrategia_id);
    }

    public function updatedProgramaId($value)
    {
        $user = Auth::user();

        $colaborador = $user->colaborador;
        $estrategias = [];

        //bloqueos de programas
        if ($user->can("sam actividad estrategias")) {//puede ver todas las estrategias
            $estrategias = Estrategia::where("programa_id", $this->programa_id)
                ->select(["id", "nombre as text"])
                ->get();
        } else {
            $estrategias = $colaborador->area
                ->estrategias_sam()
                ->where("programa_id", $this->programa_id)
                ->select(["id", "nombre as text"])
                ->get();
        }

        $this->estrategia_id = null;
        $this->emit("setEstrategia", $estrategias, $this->estrategia_id);
    }

    protected function rules()
    {
        return [
            "nombre" => [
                "required",
                Rule::unique("actividades")->ignore($this->model_id),
            ],
            "descripcion" => "required",
            "alcance" => "required",
            "eje_id" => "exists:ejes,id",
            "programa_id" => "required|exists:programas,id",
            "estrategia_id" => "required|exists:estrategias,id",
            "area_id" => "required|exists:areas,id",
            "unidad_id" => "required|exists:unidades,id",
        ];
    }

    public function resetInputFields()
    {
        $this->model_id = null;
        //$act->eje_id = $this->eje_id;
        //$act->programa_id = $this->programa_id;
        //$act->estrategia_id = $this->estrategia_id;
        $this->area_id = -1;
        $this->unidad_id = -1;
        $this->nombre = "";
        $this->descripcion = "";
        $this->alcance = "";
        $this->resetValidation();
    }

    public function store()
    {
        $this->validate();

        DB::beginTransaction();

        $act = new Actividad();
        $act->eje_id = $this->eje_id;
        $act->programa_id = $this->programa_id;
        $act->estrategia_id = $this->estrategia_id;
        $act->area_id = $this->area_id;
        $act->unidad_id = $this->unidad_id;
        $act->nombre = $this->nombre;
        $act->descripcion = $this->descripcion;
        $act->alcance = $this->alcance;
        $act->save();
        $act->etiquetas()->sync($this->etiquetas_id);

        $his = new Historico();
        $his->actividad_id = $act->id;
        $his->cantidad = 0;
        $his->cantidad_beneficiarios = 0;
        $his->inicio = Carbon::now();
        $his->estado = Historico::DRAFT;
        $his->activo = 1;
        $his->save();

        DB::commit();

        $this->resetInputFields();

        $this->emit("actividadStored");
    }
}

Modules/Sam/Http/Livewire/Actividades/Delete.php
<?php

namespace Modules\Sam\Http\Livewire\Actividades;

use Livewire\Component;
use Modules\Sam\Entities\Actividad;

class Delete extends Component
{
    public function render()
    {
        return view("sam::livewire.actividades.delete");
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($model_id)
    {
        Actividad::find($model_id)->delete();
        $this->emit("actividadDeleted");
    }
}

Modules/Sam/Http/Livewire/Actividades/Edit.php
<?php

namespace Modules\Sam\Http\Livewire\Actividades;

use Livewire\Component;
use Illuminate\Support\Facades\DB;
use Modules\Plan\Entities\Programa;
use Modules\Sam\Entities\Actividad;
use Modules\Plan\Entities\Estrategia;

class Edit extends Create
{
    protected $listeners = [
        "actividadEdit" => "edit",
    ];
    public function render()
    {
        return view("sam::livewire.actividades.edit");
    }

    public function edit(Actividad $act)
    {
        $this->model_id = $act->id;
        $this->eje_id = $act->eje_id;
        $this->programa_id = $act->programa_id;
        $this->estrategia_id = $act->estrategia_id;
        $this->area_id = $act->area_id;
        $this->unidad_id = $act->unidad_id;
        $this->nombre = $act->nombre;
        $this->descripcion = $act->descripcion;
        $this->alcance = $act->alcance;
        $this->etiquetas = $act->etiquetas->pluck("id");

        $this->emit("setArea", $act->area_id);
        $this->emit("setUnidad", $act->unidad_id);
        $this->emit("setEtiquetas", $this->etiquetas);

        $programas = Programa::where("eje_id", $this->eje_id)
            ->select(["id", "nombre as text"])
            ->get();
        $this->emit("setPrograma", $programas, $act->programa_id);

        $estrategias = Estrategia::where("programa_id", $this->programa_id)
            ->select(["id", "nombre as text"])
            ->get();
        $this->emit("setEstrategia", $estrategias, $act->estrategia_id);
    }

    public function update()
    {
        $this->validate();
        DB::beginTransaction();

        $act = Actividad::find($this->model_id);
        $act->eje_id = $this->eje_id;
        $act->programa_id = $this->programa_id;
        $act->estrategia_id = $this->estrategia_id;
        $act->area_id = $this->area_id;
        $act->unidad_id = $this->unidad_id;
        $act->nombre = $this->nombre;
        $act->descripcion = $this->descripcion;
        $act->alcance = $this->alcance;
        $act->etiquetas()->sync($this->etiquetas_id);
        $act->save();
        
        DB::commit();
        $this->resetInputFields();

        $this->emit("actividadUpdated");
    }
}

Modules/Sam/Http/Livewire/Actividades/Import.php
<?php

namespace Modules\Sam\Http\Livewire\Actividades;

use Livewire\Component;
use Modules\Sam\Entities\Etiqueta;

class Import extends Component
{
    public function render()
    {
        return view(
            "sam::livewire.actividades.import" );
    }
}

Modules/Sam/Http/Livewire/Actividades/Statistics.php
<?php

namespace Modules\Sam\Http\Livewire\Actividades;

use Livewire\Component;
use Modules\Sam\Entities\Etiqueta;

class Statistics extends Component
{
    protected $listeners = [
        "actividadStored" => '$refresh',
        "actividadDeleted" => '$refresh',
    ];

    public function render()
    {
        $etiquetas = Etiqueta::withCount("actividades")->get();
        return view(
            "sam::livewire.actividades.statistics",
            compact("etiquetas")
        );
    }
}

Modules/Sam/Http/Livewire/Etiquetas/Create.php
<?php

namespace Modules\Sam\Http\Livewire\Etiquetas;

use Livewire\Component;
use Illuminate\Validation\Rule;
use Modules\Sam\Entities\Unidad;
use Modules\Sam\Entities\Etiqueta;
use Modules\Organizacion\Entities\Area;

class Create extends Component
{
    public $nombre, $descripcion, $imagen, $color, $model_id;

    protected function rules()
    {
        return [
            "nombre" => ["required", Rule::notIn(["Otro", "Otros"])],
            "descripcion" => ["required"],
            "color" => ["required"],
            "imagen" => ["required"],
        ];
    }

    public function store()
    {
        $this->validate();

        Etiqueta::create([
            "nombre" => $this->nombre,
            "descripcion" => $this->descripcion,
            "color" => $this->color,
            "imagen" => $this->imagen,
        ]);

        $this->resetInputFields();

        $this->emit("unidadStored");
    }

    public function resetInputFields()
    {
        $this->model_id = null;
        $this->nombre = "";
        $this->descripcion = "";
        $this->color = "";
        $this->imagen = "";
    }
    public function render()
    {
        return view("sam::livewire.etiquetas.create");
    }
}

Modules/Sam/Http/Livewire/Etiquetas/Delete.php
<?php

namespace Modules\Sam\Http\Livewire\Etiquetas;

use Livewire\Component;
use Modules\Sam\Entities\Unidad;
use Modules\Sam\Entities\Etiqueta;

class Delete extends Component
{
    public function render()
    {
        return view("sam::livewire.etiquetas.delete");
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($model_id)
    {
        Etiqueta::find($model_id)->delete();
        $this->emit("unidadDeleted");
    }
}

Modules/Sam/Http/Livewire/Etiquetas/Edit.php
<?php

namespace Modules\Sam\Http\Livewire\Etiquetas;

use Livewire\Component;
use Modules\Sam\Entities\Unidad;
use Modules\Sam\Entities\Etiqueta;
use Modules\Organizacion\Entities\Area;

class Edit extends Create
{
    protected $listeners = [
        "editUnidad" => "edit",
    ];

    public function edit(Etiqueta $etiqueta)
    {
        $this->nombre = $etiqueta->nombre;
        $this->descripcion = $etiqueta->descripcion;
        $this->imagen = $etiqueta->imagen;
        $this->color = $etiqueta->color;
        $this->model_id = $etiqueta->id;
    }

    public function update()
    {
        $this->validate();

        Etiqueta::find($this->model_id)->update([
            "nombre" => $this->nombre,
            "descripcion" => $this->descripcion,
            "imagen" => $this->imagen,
            "color" => $this->color,
        ]);

        $this->emit("unidadUpdated");
    }

    public function render()
    {
        return view("sam::livewire.etiquetas.edit");
    }
}

Modules/Sam/Http/Livewire/Etiquetas/Index.php
<?php

namespace Modules\Sam\Http\Livewire\Etiquetas;

use Livewire\Component;
use Livewire\WithPagination;
use Modules\Sam\Entities\Unidad;
use Modules\Sam\Entities\Etiqueta;

class Index extends Component
{
    use WithPagination;

    public $search;

    protected $queryString = ["search"];

    protected $listeners = [
        "unidadStored" => '$refresh',
        "unidadUpdated" => '$refresh',
        "unidadDeleted" => '$refresh',
    ];

    private function getEtiquetas()
    {
        //filtrado por query
        return Etiqueta::withCount("actividades")->where(function ($q) {
            $q->where("nombre", "like", "%" . $this->search . "%")->orWhere(
                "descripcion",
                "like",
                "%" . $this->search . "%"
            );
        });
    }

    public function render()
    {
        $etiquetas = $this->getEtiquetas()->paginate(10);
        return view("sam::livewire.etiquetas.index", compact("etiquetas"));
    }
}

Modules/Sam/Http/Livewire/Historicos/Create.php
<?php

namespace Modules\Sam\Http\Livewire\Historicos;

use Livewire\Component;

class Create extends Component
{
    public function render()
    {
        return view('sam::livewire.historicos.create');
    }
}

Modules/Sam/Http/Livewire/Historicos/Index.php
<?php

namespace Modules\Sam\Http\Livewire\Historicos;

use App\Models\File;
use Livewire\Component;
use Livewire\WithPagination;
use Modules\Sam\Entities\Historico;
use Illuminate\Support\Facades\Storage;

class Index extends Component
{
    use WithPagination;

    public $search;

    protected $queryString = ["search"];

    protected $listeners = [
        "historicoStored" => '$refresh',
        "historicoUpdated" => '$refresh',
        "historicoDeleted" => '$refresh',
    ];

    public function updatingSearch()
    {
        $this->resetPage();
    }

    public function render()
    {
        $historicos = Historico::with(
            "actividad",
            "actividad.area",
            "actividad.area.revisores_sam"
        )->where("actividad_id", $this->actividad_id);
        if (!empty($this->search)) {
            $historicos->where(
                "observaciones",
                "like",
                "%" . $this->search . "%"
            );
        }
        $historicos = $historicos->orderBy("id", "desc")->paginate(10);
        return view("sam::livewire.historicos.index", compact("historicos"));
    }

    public function mount($actividad_id)
    {
        $this->actividad_id = $actividad_id;
    }

    public function download(File $file)
    {
        return Storage::download($file->path,$file->file_name);
    }
}

Modules/Sam/Resources/views/livewire/actividades/delete.blade.php
<div>
    @push('scripts')
    <script type="text/javascript">
        document.addEventListener('livewire:load', function () {
            window.livewire.on('triggerDelete', model_id => {
                Swal.fire({
                    title: '¿Esta seguro?',
                    text: '¡La actividad y todo su historial será eliminada!',
                    icon: "warning",
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#aaa',
                    confirmButtonText: 'Eliminar',
                    cancelButtonText: 'Cancelar',
                }).then((result) => {
                    //if user clicks on delete
                    if (result.value) {
                        // calling destroy method to delete
                        @this.call('destroy', model_id);
                        // success response
                        Swal.fire({ title: 'Actividad eliminada correctamente!', icon: 'success' });
                    }
                });
            });
        })
    </script>
    @endpush
</div>

Modules/Sam/Resources/views/livewire/actividades/index.blade.php
<div>
    @can("sam actividad estadisticas")
    @livewire('sam::actividades.statistics')
    @endcan
    @include('sam::livewire.actividades.filters')
    <div class="card">
        <div class="card-body">
            <div class="row align-items-center">
                <div class="col">
                    <div class="row row-cols-auto align-items-center gx-1">
                        <div>
                            <label class="form-label fw-bolder mb-0">Exportar: </label>
                        </div>
                        <div>
                            <button wire:click.prevent="exportXLSX()" type="button"
                                class="btn btn-success waves-effect waves-float waves-light"> <i
                                    class="fas fa-file-excel"></i> xlsx</button>
                            @can('sam actividad importar')
                            <button wire:click.prevent="importarXLSX()" type="button"
                                class="btn btn-success waves-effect waves-float waves-light"> <i
                                    class="fas fa-file-excel"></i> Enviar</button>
                            @endcan
                        </div>

                    </div>
                </div>
                <div class="col">
                    <form wire:submit.prevent="$emit('actividadFiltrar')">
                        <div class="row justify-content-end row-cols-auto align-items-center gx-1">
                            <div class="col">
                                <label class="form-label fw-bolder mb-0">Número de filas: </label>
                            </div>
                            <div class="col">
                                <input style="width: 100px" wire:model.defer="num_filas" id="filter-actividad"
                                    type="number" class="form-control" />
                            </div>
                            {{$actividades->links()}}
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <div class="card">
        <div class="table-responsive">
            <table class="table table-striped table-sm table-bordered">
                <thead>
                    <tr>
                        <th>ID</th>
                        <th>Fecha</th>
                        <th>Eje</th>
                        <th>Programa</th>
                        <th>Estrategia</th>
                        <th>Área</th>
                        <th>Nombre</th>
                        <th>Descripción</th>
                        <th>Alcance</th>
                        <th>Parcial</th>
                        <th>Acomulado</th>
                        <th>Observaciones u otros</th>
                        <th>Estado</th>
                        <th></th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($actividades as $index => $actividad)
                    <tr>
                        <td>
                            <span class="fw-bold">{{$actividad->id}}</span>
                        </td>
                        <td>
                            {{$actividad->created_at}}
                        </td>
                        <td>
                            <span class="fw-bold">{{$actividad->eje->nombre}}</span>
                        </td>
                        <td>
                            @if($actividad->programa)
                            <span class="fw-bold">{{$actividad->programa->nombre}}</span>
                            @endif
                        </td>
                        <td>
                            @if($actividad->estrategia)
                            <span class="fw-bold">{{$actividad->estrategia->nombre}}</span>
                            @endif
                        </td>
                        <td>
                            {{$actividad->area->nombre}}
                        </td>
                        <td>
                            {{$actividad->nombre}}
                        </td>
                        <td>
                            {{$actividad->descripcion}}
                        </td>
                        <td>
                            {{$actividad->alcance}}
                        </td>
                        <td>
                            @if($actividad->historico)
                            {{$actividad->unidad->nombre}}: {{intval($actividad->historico->cantidad)}}
                            @endif
                            <div class="text-nowrap">
                                Beneficiarios:
                                @if($actividad->historico)
                                {{intval($actividad->historico->cantidad_beneficiarios)}}
                                @endif
                            </div>
                        </td>
                        <td>
                            {{$actividad->unidad->nombre}}: {{intval($actividad->acomulado)}}
                            <div class="text-nowrap">
                                Beneficiarios:
                                {{intval($actividad->acomulado_beneficiarios)}}
                            </div>
                        </td>
                        <td>
                            @if($actividad->historico)
                            {{$actividad->historico->observaciones}}
                            @endif
                        </td>
                        @if($actividad->historico)
                        <td class="{{$actividad->historico->color}}">
                            <div class="fw-bold">
                                {{$actividad->historico->status}}
                            </div>
                        </td>
                        @else
                        <td></td>
                        @endif
                        <td>
                            <a class="btn btn-sm btn-flat-secondary waves-effect"
                                href="{{route('sam.historicos',['actividad' => $actividad->id])}}">
                                Historico</a>
                            <button data-bs-target="#editActividadModal" data-bs-toggle="modal" type="button"
                                class="btn btn-sm btn-flat-primary waves-effect"
                                wire:click="$emit('actividadEdit','{{ $actividad->id }}')">
                                Editar</button>
                            @can('sam actividad eliminar')
                            <button class="btn btn-sm btn-flat-danger waves-effect"
                                wire:click="$emit('triggerDelete','{{ $actividad->id }}')">
                                Eliminar
                            </button>
                            @endcan
                        </td>
                    </tr>
                    @endforeach
                </tbody>
            </table>
        </div>
    </div>
</div>

Modules/Sam/Resources/views/livewire/actividades/statistics.blade.php
<div class="row">
    @foreach($etiquetas as $etiqueta)
    <div class="col-lg-3 col-sm-6 col-12">
        <a class="card" href="{{route('sam.actividades')}}?ei[0]={{$etiqueta->id}}">
            <div class="card-header">
                <div>
                    <h4 class="fw-bolder">Actividades: {{$etiqueta->actividades_count}}</h2>
                    <p class="card-text">{{$etiqueta->nombre}}</p>
                </div>
                <div class="avatar {{$etiqueta->color}} p-50 m-0">
                    <div class="avatar-content">
                        {!!$etiqueta->imagen!!}
                    </div>
                </div>
            </div>
        </a>
    </div>
    @endforeach
</div>